package com.zipcodewilmington.gildedrose;


public class Inventory {
    private Item[] items;

    public Inventory(Item[] items) {
        super();
        this.items = items;
    }

    public void updateQuality02() {

        for(int i = 0; i < items.length; i ++){

            switch(items[i].getName()){

                case "Aged Brie":
                    increaseQuality(items[i]);
                    passedSellin(items[i]);
                    break;

                case "Backstage passes to a TAFKAL80ETC concert":
                    increaseQuality(items[i]);
                    checkSellinTickets(items[i]);
                    passedSellin(items[i]);
                    break;

                case "Sulfuras, Hand of Ragnaros":
                    break;

                case "Conjured Item":
                    decreaseQuality(items[i]);
                    decreaseQuality(items[i]);
                    passedSellin(items[i]);
                    break;

                default:
                    decreaseQuality(items[i]);
                    passedSellin(items[i]);
                    break;
            }
        }
    }

    private static void increaseQuality(Item item){
        if(item.getQuality() < 50){
            item.setQuality(item.getQuality() + 1);
        }
    }

    private static void decreaseQuality(Item item){
        if(item.getQuality() > 0){
            item.setQuality(item.getQuality() -1);
        }
    }

    private static void checkSellinTickets(Item item){
        //if the items sell in is less then 11
        if(item.getSellIn() < 11){
            //decrease quality
            increaseQuality(item);
            //if it is also less then 6
            if(item.getSellIn() < 6){
                //decrease quality
                increaseQuality(item);
            }
        }
    }

    private static void passedSellin(Item item){
        switch(item.getName()) {
            case "Aged Brie":
                increaseQuality(item);
                break;

            case "Backstage passes to a TAFKAL80ETC concert":
                if(item.getSellIn() < 0) {
                    item.setQuality(0);
                }
                break;

            case "Conjured Item":
                checkPassedDate(item);
                checkPassedDate(item);
                break;

            default:
                checkPassedDate(item);
                break;
        }
    }

    private static void checkPassedDate(Item item){
        if(item.getSellIn() < 0){
            decreaseQuality(item);
        }
    }

}